﻿'use strict';
angular.module('mhzs.controllers')

.controller('StepCtrl', function($scope, $stateParams, $ionicScrollDelegate, MhEnv, MhUtils, MhVer, MhPopover, MhAcc, MhAtt, MhProject, MhStep) {
	$scope.MhEnv = MhEnv;
	$scope.MhPopover = MhPopover;
	$scope.MhAcc = MhAcc;
	$scope.MhProject = MhProject;
	$scope.MhStep = MhStep;
	
	MhPopover.init($scope, '0');
	
	var cache = $scope.cache = {stepId: $stateParams.stepId, att_upload: [], uploading: 0};
	
	function form_toggle(disable) {
		$('.step_approve').toggleClass('disable', disable);
		cache.uploading = disable ? 1 : 0;
	}
	
	$scope.addImage = function() {
		MhAtt.addImage({}).then(function(r) {
			if (r && r.rtn && r.rtn.err == 0 && r.rtn.url) {
				cache.att_upload.push({url: r.rtn.url, upload: 0});
				$scope.$apply('');
			}
		});
	};
	$scope.att_upload_rm = function(index) {
		var file = cache.att_upload[index];
		if (file.upload == 0) {
			cache.att_upload.splice(index, 1);
		}
	};
	$scope.att_upload = function() {
		//mhapp.img_add_upload({btn: $(this), p: $('#step-page'), attachType: 'step_' + mhapp.cache.step_id, keyName: null, j_img_cnt: j_img_cnt, backpage: 'step', title: '进度现场照片' });
		if (cache.uploading == 0) {
			//cache.uploading = 1;
			form_toggle(true);
			MhAtt.fileUpload({$scope: $scope, files: cache.att_upload, attachType: 'step_' + cache.stepId, keyName: null}).then(function() {
				//cache.uploading = 0;
				//$scope.$apply('');
				form_toggle(false);
				MhUtils.toast({type:'success', message: '上传成功！'});
			});
		}
	};
	
	$scope.approve = function() {
		var btn = event.target;
		if ($(btn).is('.disable')) return;
		//$(btn).toggleClass('disable');
		var approve = $(btn).is('.step_approve_undo') ? 'undo' : $(btn).is('.step_approve_doing') ? 'doing' : 'done';
		form_toggle(true);
		MhStep.approve({id: cache.stepId, approve: approve}).then(function(_step) {
			form_toggle(false);
			MhUtils.toast({type:'success', message: '提交成功！'});
		});
	};
	
	function load_data() {
		var prjId = MhProject.cache.currentId;
		MhStep.step(prjId, $scope.cache.stepId).then(function(r) {
			$scope.stepWrap = MhStep.cache._steps[cache.stepId];
		}, function() {});
	}
	
	load_data();
	
	

})

;
