﻿angular.module('mhzs.services')

.factory('MhAcc', function($resource, $http, $rootScope, $state, $stateParams, $q, $ionicSideMenuDelegate, MhEnv, MhUtils) {
  //var base_path = MhEnv.getAppPath();
  var cache = {token: {}};

  var login = function(scope, mobile, pwd, callback) {
	var deferred = $q.defer();
	//var un = $('#username').val();	
	//var pwd = $('#password').val();
	var target = $(event.target).parents('body:first');
	jQuery.ajax({
		type: 'POST'
		, url: MhEnv.api + Const.Url_SignIn
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		, crossDomain: true
		, cache: false
		//, offline: true
		//, expires: 10000
		, data: {username: mobile, password: pwd, 'result.json':1}
		, success: function(r, status, requestCode,response, xhr) {
			//if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error,msg) {
			MhUtils.toast({type: 'error', target: target, message: '网络连接出现问题！\n(SignIn)\n' + msg});
			deferred.reject('1');
		}
	});
	return deferred.promise;
  };

  var logout = function(auto_redirect) {
	var deferred = $q.defer();
	var target = event ? $(event.target).parents('body:first') : null;
	$.ajax({type: 'POST'
		, url: MhEnv.api + Const.Url_SignOut
		, data: {}
		//, dataType: 'json'
		, timeout: 20000
		, error: function(xhr, errorType, error) {
			MhUtils.toast({type: 'error', target: target, message: '网络连接出现问题！\n(signOut)\n' + msg});
			deferred.reject('1');
		}, success: function(r, status,requestCode) {
			localStorage.removeItem('user_auth_id');
			localStorage.removeItem('user_id');
			//cache.authTime = new Date();
			cache.authFlag = false;
			cache.token = {};
			//mhapp.cache.user = null;
			//mhapp.cache.listRole = null;
			//mhapp.cache.step_id = null;
			//AppTools.db_set_auth({act: 'delete', callback: function() {
			//	$.mobile.changePage('#login-page');
			//}});
			deferred.resolve(r);
			if (auto_redirect) {
				$ionicSideMenuDelegate.toggleLeft(false);
				$state.go('login');
			}
		}
	});
	return deferred.promise;
  };
  
  //var checkLogin = function(auto_redirect, scope, callback) {
  var checkLogin = function(auto_redirect, useronly) {
	var deferred = $q.defer();
	var url = MhEnv.api + Const.Url_IndexUser;
	url = url.replace(/(\$\{useronly\})/, useronly || 1);
	jQuery.ajax({
		type: 'GET'
		, url: url
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		, data: {rnd: Math.random()}
		, success: function(r, status, requestCode,response, xhr) {
			if (r.authId != null && r.user != null) {
				//AppTools.db_set_auth({data: r, callback: args.callback, auth_id: r.authId, user_id: r.user.id, user_name: r.user.name, login_time: r.auth.loginTime.toDate().format('yyyy-MM-dd HH:mm:ss'), login_ip: r.auth.loginIp, update_time: new Date().format('yyyy-MM-dd HH:mm:ss')});
				cache.authTime = new Date();
				cache.authFlag = true;
				cache.token = r;
				cache.rolePm = cache.token.listRole.getItem('pm', 'aliasName');
				cache.roleSup = cache.token.listRole.getItem('sup', 'aliasName');
				cache.roleCust = cache.token.listRole.getItem('cust', 'aliasName');
				localStorage['user_auth_id'] = r.authId;
				//localStorage['user_mobile'] = r.user.mobile;
				localStorage['user_id'] = r.auth.userId;
				deferred.resolve(r);		// {user: <>, authId: 'xxxxx', auth: <>}
			} else {
				cache.authFlag = false;
				//AppTools.db_set_auth({data: null, callback: args.callback, act: 'delete'});
				if (auto_redirect) {
					$rootScope.state0 = {name: $state.$current.name, params: angular.extend({}, $stateParams)};
					$state.go('login');
				}
				deferred.reject('1');
			}
			//if (args.callback) args.callback(r);
		}, error: function(xhr, errorType, error,msg) {
			//alert( '获取用户信息出错！' );
			//window.plugins.toast.show('获取用户信息出错，请检测网络连接！\n' + msg, 'short', 'bottom');
			cache.authFlag = false;
			if (auto_redirect) {
				$rootScope.state0 = {name: $state.$current.name, params: angular.extend({}, $stateParams)};
				$state.go('login');
			}
			deferred.reject('2');
		}
	});
	return deferred.promise;
  };
  
  var checkLogin2 = function(args) {	//r, show_err, auto_redirect
	if (args.r && args.r.autherr) {
		if (args.deferred) args.deferred.reject(args.r);
		if (args.show_err) {
			var msg = '请先登录！\n';
			if (args.autherr_msg) msg = args.autherr_msg;
			MhUtils.toast({type: 'error', message: msg});
			if (args.auto_redirect) {
				setTimeout(function() {
					$state.go('login');
				}, 2000);
			}
		}
	} else {
		if (args.deferred) args.deferred.resolve(args.r);
	}
  };
  
  
  var process = function(args) {
	var deferred = $q.defer();
	var url = MhEnv.api + Const.Url_ProcIndex;
	url = url.replace(/(\$\{auth_key\})/, args.auth_key)
		.replace(/(\$\{returnUrl\})/, args.returnUrl)
		.replace(/(\$\{contentPath\})/, Const.Url_ContentPath)
	;
	jQuery.ajax({
		type: 'GET'
		, url: url
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		, data: {rnd: Math.random()}
		, success: function(r, status, requestCode,response, xhr) {
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error,msg) {
			//alert( '获取用户信息出错2！' );
			//window.plugins.toast.show('获取proc信息出错2！', 'short', 'bottom');
			if (args.callback) args.callback({});
			deferred.reject('2');
		}
	});
	return deferred.promise;
  }

  var resourceGet =  $resource(MhEnv.api + '/user/get.htm', {}, {
    query: {method: 'get', isArray:false, params: {userId: null}, timeout: 20000}
  });
  var get = function(scope, userId, callback) {
	return resourceGet.query({
	  userId: userId
    }, function(r) {
      return callback && callback(r);
    });
  };
  


  /** reg */
  //var reg = function(scope, mobile, code, codeOrder, pwd, callback) {
  var reg = function(args) {
	var deferred = $q.defer();
	jQuery.ajax({
		type: 'POST'
		, url: MhEnv.api + Const.Url_RegJoin
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		//, offline: true
		//, expires: 10000
		, data: {d: args.d, vcode: args.vcode, name: args.name, mobile: args.mobile, password:args.password}
		, success: function(r, status, requestCode,response, xhr) {
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error) {
			MhUtils.toast({type: 'error', target: target, message: '网络连接出现问题！\n(reg)\n' + error});
			deferred.reject('error');
		}
	});
	return deferred.promise;
  };
  /** repwd */
  var repwd = function(args) {
	var deferred = $q.defer();
	$.ajax({
		type: 'POST'
		, url: MhEnv.api + Const.Url_Repwd
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		, crossDomain: true
		, cache: false
		//, offline: true
		//, expires: 10000
		, data: {'result.pwd0': args.pwd0, 'result.pwd1': args.pwd1, 'result.pwd2': args.pwd2, 'result.act': 'repwd', 'result.json':1}
		, success: function(r, status, requestCode,response, xhr) {
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error) {
			//window.plugins.toast.show('网络连接出现问题！\n(' + MhEnv.api + Const.Url_Repwd + ')\n' + error, 'short', 'bottom');
			MhUtils.toast({type: 'error', target: target, message: '网络连接出现问题！\n(repwd)\n' + error});
			deferred.reject(error);
		}
	});
	return deferred.promise;
  };
  
  var repwd2 = function(args) {
	var deferred = $q.defer();
	$.ajax({
		type: 'POST'
		, url: MhEnv.api + Const.Url_ForgetpwdRepwd
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		//, offline: true
		//, expires: 10000
		, data: {d: args.d, vcode: args.vcode, name: args.name, mobile: args.mobile, password:args.password}
		, success: function(r, status, requestCode,response, xhr) {
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error) {
			//window.plugins.toast.show('网络连接出现问题！\n(' + MhEnv.api + Const.Url_RegJoin + ')', 'short', 'bottom');
			MhUtils.toast({type: 'error', target: target, message: '网络连接出现问题！\n(repwd2)\n' + error});
			deferred.reject(error);
		}
	});
	return deferred.promise;
  };

  var userRole = function(args) {
	var deferred = $q.defer();
	var url = MhEnv.api + Const.Url_UserRole;
	//url += '&rnd=' + Math.random();
	jQuery.ajax({
		type: 'GET'
		, url: url
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		//, offline: true
		//, expires: 10000
		, data: {}
		, success: function(r, status, requestCode,response, xhr) {
			//if (window.show_project) show_project(r);
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error) {
			MhUtils.toast({type: 'error', message: '获取用户角色失败！\n(' + MhEnv.api + Const.Url_UserRole + ')\n' + error});
			deferred.reject(error);
		}
	});
	return deferred.promise;
  };
  
  var msgs = function(args) {
	var deferred = $q.defer();
	var url = MhEnv.api + Const.Url_Msgs;
	url = url.replace(/(\$\{prjId\})/, args.prjId);
	if (args.start != undefined) { url += '&start=' + args.start;}
	if (args.max != undefined) { url += '&max=' + args.max;}
	url += '&rnd=' + Math.random();
	jQuery.ajax({
		type: 'GET'
		, url: url
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		//, offline: true
		//, expires: 10000
		, data: {}
		, success: function(r, status, requestCode,response, xhr) {
			//if (window.show_project) show_project(r);
			if (args.callback) args.callback(r);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error,msg) {
			//alert('error');
			//alert(msg);
			MhUtils.toast({type: 'error', message: '获取消息失败！\n(' + MhEnv.api + Const.Url_Msgs + ')\n' + error});
			deferred.reject(error);
		}
	});
	return deferred.promise;
  };
  
  var msgSend = function(args) {
	var deferred = $q.defer();
	var url = MhEnv.api + Const.Url_MsgSend;
	jQuery.ajax({
		type: 'POST'
		, url: url
		, timeout: Const.Http_Timeout
		, dataType: 'json'
		//, offline: true
		//, expires: 10000
		, data: {prjId: args.prjId, myrole: args.myrole, wechatTo: args.wechatTo, content: args.content}
		, success: function(r, status, requestCode,response, xhr) {
			//if (window.show_project) show_project(r);
			if (args.callback) args.callback(r, args);
			deferred.resolve(r);
		}, error: function(xhr, errorType, error,msg) {
			//alert('error');
			//alert(msg);
			//window.plugins.toast.show('发送消息失败！\n(' + MhEnv.api + Const.Url_MsgSend + ')\n' + msg, 'short', 'bottom');
			MhUtils.toast({type: 'error', message: '发送消息失败！\n(' + MhEnv.api + Const.Url_MsgSend + ')\n' + error});
			deferred.reject(error);
		}
	});
	return deferred.promise;
  };
  
  var getVerifyCode = function(args) {
	var deferred = $q.defer();
		$.ajax({
			type: 'POST'
			, url: MhEnv.api + Const.Url_RegFetchVerify
			, timeout: Const.Http_Timeout
			, data: {t: args.phone, f: args.seq, m: args.m, a: args.acc ? 1: 0}
			, success: function(r, status, requestCode,response, xhr) {
				if (args.callback) args.callback(r);
				deferred.resolve(r);
			}, error: function(xhr, errorType, error) {
				//window.plugins.toast.show('网络连接出现问题！\n(' + Const.Url_Site + Const.Url_RegFetchVerify + ')', 'short', 'bottom');
				MhUtils.toast({type: 'error', message: '网络连接出现问题！\n(' + MhEnv.api + Const.Url_RegFetchVerify + ')\n' + error});
				deferred.reject(error);
			}
		});	
	return deferred.promise;
  };
  
  return {
	cache: cache
	, checkLogin: checkLogin
	, checkLogin2: checkLogin2
	, login: login
	, logout: logout
	, get: get
	, reg: reg
	, repwd: repwd
	, repwd2: repwd2
	, userRole: userRole
	, msgs: msgs
	, msgSend: msgSend
	, getVerifyCode: getVerifyCode
  };
})
;
