﻿angular.module('mhzs.services')

.factory('MhAtt', function($rootScope, $state, $stateParams, $q, $ionicActionSheet, MhEnv, MhUtils, MhProject) {
  //var base_path = MhEnv.getAppPath();
	var cache = {files: {}, viewer: {}};
	
	var refreshAtts = function(atts) {
		for (var i=0; atts && i<atts.length; i++) {
			var att1 = atts[i];
			var att = cache.files[att1.id];
			if (!att) {
				att = cache.files[att1.id] = att1;
			} else {
				for (var k in att1) {
					att[k] = att1[k];
				}
			}
		}
	};

	var att_info = function(args) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_Attach_Info;
		url = url.replace(/(\$\{id\})/, args.id);
		//alert(url);
		jQuery.ajax({
			type: 'GET'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode,response, xhr) {
				if (args.callback) args.callback(r);
				refreshAtts([r.model]);
				deferred.resolve(r);
			}, error: function(xhr, errorType, error) {
				try {
					MhUtils.toast({type: 'error', message: '获取文件(' + args.id + ')信息失败！\n(' + MhEnv.api + Const.Url_Attach_Info + ')\n' + error});
					deferred.reject(error);
				} catch (e) {}
			}
		});
		return deferred.promise;
	};
	
	var att_info2 = function(args) {
		var deferred = args.deferred || $q.defer();
		var att = cache.files[args.id];
		if (!att) {
			args.deferred = deferred;
			att_info({id: args.id}).then(function() {
				att_info2(args);
			}, function() {
				//
			});
		} else {
			var url_down = url({id: args.id, full: args.full, jsonflag: 1});
			jQuery.getJSON(url_down, function(r) {
				att['url' + (args.full == 1 ? '_f' : '')] = r.url;
				//var args2 = $.extend({}, args || {}, true);
				//args2.url = MhEnv.api + r.url;
				//args2.fileExt = r.ext;
				deferred.resolve(r);
			}); 
		}
		return deferred.promise;
	};
	
	var download = function(args) {
		if (window.FileTransfer) {
			var fileURL = args.saveto;	//'cdvfile://localhost/documents/downloads/x1.png';
			var fileTransfer = new FileTransfer();
			var uri = encodeURI(args.url);	//source url
			fileTransfer.download(
				uri,
				fileURL,
				function(entry) {
					//alert(JSON.stringify(entry));
					//alert('ok;\n' + entry.toURL());
					//$('#test_img').attr('src', fileURL);
					//$('#test_img2').attr('src', entry.toURL());
					//console.log("download complete: " + entry.toURL());
					if (args.callback) args.callback(entry, args);
				},
				function(error) {	//error		{source: , target: , code: }
					if (args.cberror) args.cberror(error, args);
				},
				false,
				{
					headers: {
						"Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
					}
				}
			);	
		}
	};
	
	var upload = function(args) {
		var fileURL = args.file;	//'cdvfile://localhost/documents/downloads/x1.png';
		var params = args.params;
		var options = new FileUploadOptions();
		options.fileKey = "file";
		options.fileName = params.fileName != undefined && params.fileName != null ? params.fileName : fileURL.substr(fileURL.lastIndexOf('/') + 1);
		//options.mimeType = "text/plain";
		var p = options.fileName.lastIndexOf('.');
		var fileExt = p == -1 || p == options.fileName.length-1 ? 'jpg' : options.fileName.substring(p+1);
		options.mimeType = "image/" + fileExt;
		//params.value1 = "test";
		//params.value2 = "param";

		options.params = params;
		var upload_url = MhEnv.api + Const.Url_Attach_Upload;

		var ft = new FileTransfer();
		ft.upload(fileURL, encodeURI(upload_url), args.suc, args.fail, options);
	};
	
	var camera_clear = function() {
		try {
			resolveLocalFileSystemURL('cdvfile://localhost/cache/imgchoose/', function (entry) {
				entry.removeRecursively();
			});
		} catch (e) {
			//alert(e);
		}
		try {
			resolveLocalFileSystemURL('cdvfile://localhost/cache-external/imgchoose/', function (entry) {
				entry.removeRecursively();
			});
		} catch (e) {
			//alert(e);
		}
	};
	
	var camera = function(args) {
		var deferred = $q.defer();
		navigator.camera.getPicture(function(imageURI) {
			resolveLocalFileSystemURL(imageURI, function (entry) {
				//entry.copyTo();
				entry.getParent(function(dir) {
					dir.getDirectory('imgchoose', {create:true, exclusive:false}, function(dir1) {
						var rnd = '000000' + parseInt(Math.random()*1000000);
						rnd = rnd.substring(rnd.length - 6);
						entry.copyTo(dir1, new Date().format('yyyyMMddHHmmss') + rnd + '.jpg', function(file1) {
							//alert( JSON.stringify(file1) );	//file1.nativeURL	file1.toURL()
							args.rtn = {err: 0, url: file1.toURL()};
							if (args.dom) {
								if (args.dom[0].tagName == 'IMG') {
									args.dom.attr('src', file1.toURL());
								} else {
									args.dom.css({'background-image': 'url(' + file1.toURL() + ')'});
								}
							}
							if (args.callback) args.callback( args );
							deferred.resolve(args);
						});
					});
				});
			});
		}, function(message) {
			setTimeout(function() {
				//alert('Failed because: ' + message);
				args.rtn = {err: 1, msg: message};
				if (args.callback) args.callback( args );
				deferred.reject(args);
			}, 0);
		}, { quality: 85,
			targetWidth: 1920,
			targetHeight: 1920,
			destinationType: Camera.DestinationType.FILE_URI
			, sourceType: args.lib ? Camera.PictureSourceType.PHOTOLIBRARY : Camera.PictureSourceType.CAMERA
		});
		
		return deferred.promise;
	};
	
	var url = function(args) {	//id, full, jsonflag
		var img_down = MhEnv.api + Const.Url_Attach_Down;
		img_down = img_down.replace(/(\$\{id\})/, args.id);
		if (args.full != 1) {
			img_down += '&s=1';
		}
		if (args.jsonflag == 1) {
			img_down += '&j=1';
		}
		//console.log('img_down', img_down);
		return img_down;
	}
	
	var isImage = function(att) {
		if (!att || !att.fileExt) return false;
		var fileExt = att.fileExt.toLowerCase();
		if (fileExt == 'jpg' || fileExt == 'png' || fileExt == 'gif' || fileExt == 'jpeg') {
			return true;
		}
		return false;
	}
	
	var viewData = function(viewId) {
		var view = cache.viewer[viewId];
		if (!view) {
			view = cache.viewer[viewId] = {list: [], current: -1};
		}
		return view;
	}
	
	var viewPush = function(viewId, attId, index) {
		var view = viewData(viewId);
		if (attId) {
			var idx = view.list.indexOf(attId);
			if (idx == -1) {
				if (index === undefined) {
					view.list.push(attId);
				} else {
					view.list.splice(index, 0, attId);
				}
			}
			if (view.current == -1) view.current = 0;
		}
	}
	
	var viewClear = function(viewId) {
		var view = viewData(viewId);
		if (view.list.length) {
			view.list = [];
			view.current = -1;
		}
		return view;
	}
	
	var checkFileInLocal = function(args) {
		var deferred = $q.defer();
		var local_path = MhUtils.platform.isAndroid ? 'cdvfile://localhost/cache-external' : 'cdvfile://localhost/cache';
		var img_cache = local_path + '/images/' + args.id + (args.full == 1 ? '_f' : '') + '.' + args.fileExt;
		//alert('checkFileInLocal: 001\nresolveLocalFileSystemURL=' + (window.resolveLocalFileSystemURL?'[ok]':'[null]') + '\n' + img_cache);
		if (window.resolveLocalFileSystemURL) {
			resolveLocalFileSystemURL(img_cache
				, function (entry) {
					//file found
					//alert('checkFileInLocal: file found');
					deferred.resolve(entry);
				}, function(error) {
					//file not exists
					//alert('checkFileInLocal: file not found');
					deferred.reject({error: error, local: img_cache});
				}
			);
		} else {
			deferred.reject({error: 'resolveLocalFileSystemURL is undefined', local: img_cache});
		}
		return deferred.promise;
	}
	
	var showImage = function(args) {	//dom, id, full
		var deferred = args.deferred || $q.defer();
		var att = cache.files[args.id];
//console.log('showImage', att, args);
		if (!att) {
			args.deferred = deferred;
			att_info({id: args.id}).then(function() {
				//showImage(args);
			}, function(error) {
				deferred.reject(error);
			});
		} else {
			checkFileInLocal({id: args.id, full: args.full, fileExt: att.fileExt}).then(function(file) {
//console.log('showImage', '222');
				//alert( 'showImage: \n' + file.toURL() + ' dom:' + args.dom);
				//showImageByUrl({dom: args.dom, url: file.toURL()});
				att.url_local = file.toURL();
				if (!MhUtils.platform.isAndroid) {	//@todo: fix ios9 bug here
					//att.url_local = null;
					//att.url_remote = url({id: args.id, full: args.full});
				}
				var args2 = $.extend({file: file}, args || {}, true);
				args2.att = att;
				deferred.resolve(args2);
			}, function(err) {
				//xxxxxxxxxxxxxxxx
//console.log('showImage', '333');
				var url_down = url({id: args.id, full: args.full});
				//alert( 'url_down:\n' + url_down );
				att_info2({id: args.id, full: args.full}).then(function(r) {
					download({url: MhEnv.api + r.url, saveto: err.local});
				});
				//showImageByUrl({dom: args.dom, url: url_down});
				att.url_remote = url_down;
				var args2 = $.extend(err, args || {}, true);
				args2.att = att;
				deferred.resolve(args2);
			});
		}
		return deferred.promise;
	};
	
	var showImageByUrl = function(args) {	//dom, url
		if (args.dom.tagName == 'IMG') {
			//alert( 'dom is img' );
			args.dom.src = args.url;
		} else {
			//alert( 'dom is not img, tagName=' + args.dom.tagName );
			//$(args.dom).css({'background-color': '#00f'});
			$(args.dom).css({'background-image': 'url(' + args.url + ')'});
		}
	};
	
	//拍照或者选择照片
	var addImage = function(args) {
		var deferred = args.deferred || $q.defer();
		var items = [{share: 'camera', text: '拍照'}
			, {share: 'piclib', text: '从手机相册选择'}
		];
		var buttons = [];
		for (var i=0; i<items.length; i++) {
			buttons.push({text: '<i share="' + items[i].share + '">' + items[i].text + '</i>'});
		}
		$ionicActionSheet.show({
            titleText: null
            , buttons: buttons
            , cancelText: '取消'
            , cancel: function() {
                console.log('CANCELLED');
            }
            , buttonClicked: function(index) {
                console.log('BUTTON CLICKED', index);
				//var item = items[index];
				//var img = getHostUrl(MhEnv.api + '/img/icon.png');
				//share(6, item.share, '[好玩]', '旅行观天下', [img], getHostUrl(location.href) );
				if (index == 0) {
					camera({lib: 0}).then(function(r) {
						deferred.resolve(r);
					}, function(r) {
						//reject
						deferred.resolve(r);
					});
				} else if (index == 1) {
					camera({lib: 1}).then(function(r) {
						deferred.resolve(r);
					}, function(r) {
						//reject
						deferred.resolve(r);
					});
				}
				return true;
            }
            , destructiveButtonClicked: function() {
                console.log('DESTRUCT');
                return true;
            }
        });
		return deferred.promise;
	};
	
	var fileUpload_check = function(args) {
		var r = -1;
		for (var i=0; args.files && i<args.files.length; i++) {
			r = r == -1 ? args.files[i].upload : Math.min(r, args.files[i].upload);
		}
		return r;
	};
	
	var fileUpload = function(args) {
		var deferred = $q.defer();
		var tableId = MhProject.cache.currentId;
		for (var i=0; args.files && i<args.files.length; i++) {
			var file = args.files[i];
			file.upload = 1;
			file.tempId = i;
			var fileName = new Date().format('yyyyMMddHHmmss') + '.jpg';
			upload({file: file.url
				, params:  {
						tableName: 'ZS_PRJ'
						, tableId: tableId
						, attachType: args.attachType	//'step_' + mhapp.cache.step_id
						, fileName: fileName
						, keyName: args.keyName
						//, des: $('#img_add_des').val()
						, filePath: 'ZS_PRJ-' + parseInt(tableId/1000) + '\\ZS_PRJ_' + tableId
						, tempId: i
						, json: 2
					}
				, suc: function(r) {
					//alert( JSON.stringify(r) );	// {id: 111, tempId: 0}
					var x = JSON.parse(r.response);
					var idx = args.files.indexOf(x.tempId, 'tempId');
					if (idx != -1) {
						var file = args.files[idx];
						file.id = x.id;
						file.upload = 2;
						if (args.$scope) args.$scope.$apply('');
					}
					var chk = fileUpload_check(args);
					if (chk == 2) {
						deferred.resolve();
					}
				}, fail: function(error) {
					//alert(error);
				}
			});
		}
		return deferred.promise;
	};
	
	var get = function(id) {
		return cache.files[args.id];
	};
  
  return {
	cache: cache
	, get: get
	, refreshAtts: refreshAtts
	, att_info: att_info
	, att_info2: att_info2
	, download: download
	, upload: upload
	, camera_clear: camera_clear
	, camera: camera
	, isImage: isImage
	, url: url
	, viewData: viewData
	, viewPush: viewPush
	, viewClear: viewClear
	, checkFileInLocal: checkFileInLocal
	, showImage: showImage
	, showImageByUrl: showImageByUrl
	, addImage: addImage
	, fileUpload: fileUpload
  };
})
;
