﻿angular.module('mhzs.services')

.factory('MhCheck', function($rootScope, $state, $stateParams, $q, MhEnv, MhUtils, MhAtt, MhAcc, MhProject) {
  //var base_path = MhEnv.getAppPath();
	var cache = {_checks: {}, _checkItems: {}, _checkLogs: {}};

	var getItem = function(prjId, id) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_CheckItem;
		url = url.replace(/(\$\{id\})/, id)
			.replace(/(\$\{prjId\})/, prjId)
		;
		jQuery.ajax({
			type: 'GET'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode) {
				//if (args.callback) args.callback(r);
				//console.log('checkItem_wrap', r);
				MhAcc.checkLogin2({r: r, show_err: true, auto_redirect: true});
				// r.listCheckLog  r.listAttach
				if (r.checkItem && r.checkItem.id) {
					var logIds = [];
					for (var i=0; i<r.listCheckLog.length; i++) {
						logIds.push( 'checkLog_' + r.listCheckLog[i].id );
					}
					setItem(prjId, r.checkItem.id, r);
					var viewId = 'checkItem_' + r.checkItem.id;
					var view = MhAtt.viewClear(viewId);
//console.log('viewId', viewId, r.listAttach);
					MhAtt.refreshAtts(r.listAttach);
					for (var i=0; r.listAttach && i<r.listAttach.length; i++) {
						if ( logIds.indexOf( r.listAttach[i].attachType ) != -1 ) {
							MhAtt.viewPush(viewId, r.listAttach[i].id);
						}
					}
				}
				deferred.resolve(r);
			}, error: function(xhr, errorType, error) {
				//alert('error');
				//alert(error + ':' + msg);
				//alert('获取进度信息出错！');
				MhUtils.toast({type: 'error', message: '获取材料信息出错！\n(' + MhEnv.api + Const.Url_CheckItem + ')\n' + msg});
				deferred.reject(error);
			}
		});
		return deferred.promise;
	};
	
	var setItem = function(prjId, id, _checkItemWrap, itemonly) {
		if (!cache._checkItems[id]) cache._checkItems[id] = {checkItem: {}};
		if (itemonly) {
			if (_checkItemWrap.checkItem) $.extend(cache._checkItems[id].checkItem, _checkItemWrap.checkItem);
		} else {
			$.extend(cache._checkItems[id], _checkItemWrap);
		}
		if (_checkItemWrap.checkItem) {
			MhProject.setCheckItem(prjId, _checkItemWrap.checkItem.id, _checkItemWrap.checkItem);
		}
	};
	
	var approve = function(args) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_CheckLogApprove;
		jQuery.ajax({
			type: 'POST'
			, url: url
			, data: {checkItemId:args.checkItemId
				, approve: args.approve
				, checkId: args.checkId
				, prjId: args.prjId
				, logId: args.logId
				, ro: args.ro
				, idea: args.idea}
			, dataType: 'json'
			, timeout: 20000
			, error: function(xhr, errorType, error) {
				alert('网络连接出现问题！\n(' + url + ')');
				deferred.reject(error);
			}, success: function(data, status,requestCode,response, xhr) {
				//alert(JSON.stringify(data));
				//alert('suc:' + data);
				//alert(data.log);
				//return;
				MhAcc.checkLogin2({r: data, show_err: true, auto_redirect: true});
				deferred.resolve(data);	//{ro: 'xx', log: {}}
			}
		});
		return deferred.promise;
	};
	
	var getCheck = function(prjId, checkId) {
		return MhProject.getCheck(prjId, checkId);
	};
	
	var getLogLast = function(checkItemWrap) {
		if (checkItemWrap.listCheckLog && checkItemWrap.listCheckLog.length>0) {
			return checkItemWrap.listCheckLog[checkItemWrap.listCheckLog.length-1];
		}
		return null;
	};
	
	var getLogCurrent = function(checkItemWrap) {
		var listCheckLog = checkItemWrap.listCheckLog;
		var logx = null;
		if (listCheckLog && listCheckLog.length!=0) {
			for (var i=0; i<listCheckLog.length; i++) {
				if (listCheckLog[i].chk == 0) {
					logx = listCheckLog[i];
				}
			}
		}
		return logx;
	};
	
	var getLogAtt = function(checkItemWrap) {
		var r = {};
		var listAttach = checkItemWrap.listAttach;
		for (var i=0; listAttach && i<listAttach.length; i++) {
			var att = listAttach[i];
			var attLog = r[att.attachType];
			if (!attLog) attLog = r[att.attachType] = {};
			var attRole = attLog[att.keyName];
			if (!attRole) attRole = attLog[att.keyName] = [];
			attRole.push( att );
		}
		return r;
	};
	
	var getLogx = function(checkItemWrap) {
		var logAtts = getLogAtt(checkItemWrap);
		var listCheckLog = checkItemWrap.listCheckLog;
		var logLast = null;
		var logCurrent = null;
		var chkClass = -1;
		var chkText = '';
		if (listCheckLog && listCheckLog.length!=0) {
			logLast = listCheckLog[listCheckLog.length-1];
			for (var i=0; i<listCheckLog.length; i++) {
				if (listCheckLog[i].chk == 0) {
					logCurrent = listCheckLog[i];
				}
			}
		}
		if (checkItemWrap.checkItem.chk == 1) {
			chkClass = 'log_chk_yes';
			chkText = '已验收';
		} else {
			if (logCurrent != null) {
				if (logCurrent.chkPm != 10) {
					chkText = '等待项目经理发起申请';
					chkClass = 'log_chk_wait';
				} else if (logCurrent.chkSup == 0) {
					chkText = '等待监理验收';
					chkClass = 'log_chk_wait';
				} else if (logCurrent.chkSup == -2) {
					chkText = '监理验收未通过';
					chkClass = 'log_chk_no';
				} else if (logCurrent.chkCust == 0) {
					chkText = '等待客户验收';
					chkClass = 'log_chk_wait';
				} else if (logCurrent.chkCust == -2) {
					chkText = '客户验收未通过';
					chkClass = 'log_chk_no';
				} else if (logCurrent.chkCust == 10) {
					chkText = '客户验收通过';
					chkClass = 'log_chk_yes';
				}
			} else if (logLast != null) {
				if (logLast.chkPm != 10) {
					chkText = '等待项目经理发起申请';
					chkClass = 'log_chk_wait';
				} else if (logLast.chkSup == 0) {
					chkText = '等待监理验收';
					chkClass = 'log_chk_wait';
				} else if (logLast.chkSup == -2) {
					chkText = '监理验收未通过';
					chkClass = 'log_chk_no';
				} else if (logLast.chkCust == 0) {
					chkText = '等待客户验收';
					chkClass = 'log_chk_wait';
				} else if (logLast.chkCust == -2) {
					chkText = '客户验收未通过';
					chkClass = 'log_chk_no';
				} else if (logLast.chkCust == 10) {
					chkText = '客户验收通过';
					chkClass = 'log_chk_yes';
				}
			} else {
				chkText = '等待项目经理发起申请';
				chkClass = 'log_chk_wait2';
			}
		}
		return {logAtts: logAtts, last: logLast, current: logCurrent, chkClass: chkClass, chkText: chkText};
	};
	
	var listItem = function(args) {	//{checkId:n, allItem: []}
		if (!args.checkId || !args.allItem) return null;
		var list = [];
		for (var i=0; i<args.allItem.length; i++) {
			var item = args.allItem[i];
			if (item.checkId == args.checkId) {
				list.push( item );
			}
		}
		return list;
	};
	
  return {
	cache: cache
	, getItem: getItem
	, approve: approve
	, setItem: setItem
	, getCheck: getCheck
	, getLogx: getLogx
	, getLogLast: getLogLast
	, getLogCurrent: getLogCurrent
	, listItem: listItem
  };
})
;
