﻿angular.module('mhzs.services')

.factory('MhMaterial', function($rootScope, $state, $stateParams, $q, MhEnv, MhUtils, MhAtt, MhAcc, MhProject) {
  //var base_path = MhEnv.getAppPath();
	var cache = {_materials: {}};

	var get = function(prjId, id) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_MaterialGroup;
		url = url.replace(/(\$\{id\})/, id)
			.replace(/(\$\{prjId\})/, prjId)
		;
		jQuery.ajax({
			type: 'GET'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode) {
				//if (args.callback) args.callback(r);
				//console.log('materialGroup_wrap', r);
				MhAcc.checkLogin2({r: r, show_err: true, auto_redirect: true});
				if (r.materialGroup && r.materialGroup.id) {
					setData(r.materialGroup.id, r);
					var viewId = 'material_' + r.materialGroup.id;
					var view = MhAtt.viewClear(viewId);
					MhAtt.refreshAtts(r.listAttach);
					for (var i=0; r.listAttach && i<r.listAttach.length; i++) {
						MhAtt.viewPush(viewId, r.listAttach[i].id);
					}
				}
				deferred.resolve(r);
			}, error: function(xhr, errorType, error) {
				//alert('error');
				//alert(error + ':' + msg);
				//alert('获取进度信息出错！');
				MhUtils.toast({type: 'error', message: '获取材料信息出错！\n(' + MhEnv.api + Const.Url_MaterialGroup + ')\n' + msg});
				deferred.reject(error);
			}
		});
		return deferred.promise;
	};
	
	var setData = function(id, _materialWrap, materialonly) {
		if (!cache._materials[id]) cache._materials[id] = {materialGroup: {}};
		if (materialonly) {
			if (_materialWrap.materialGroup) $.extend(cache._materials[id].materialGroup, _materialWrap.materialGroup);
		} else {
			$.extend(cache._materials[id], _materialWrap);
		}
		if (_materialWrap.materialGroup) {
			MhProject.setMaterial(_materialWrap.materialGroup.prjId, _materialWrap.materialGroup.id, _materialWrap.materialGroup);
		}
	};
	
	var approve = function(args) {
		var deferred = $q.defer();
		var approve = args.approve;
		var url = MhEnv.api + Const.Url_MaterialGroupApprove;
		jQuery.ajax({
			type: 'POST'
			, url: url
			, data: {materialGroupId:args.id, approve: approve}
			, dataType: 'json'
			, timeout: 20000
			, error: function(xhr, errorType, error) {
				alert('网络连接出现问题！\n(' + url + ')');
				deferred.reject(error);
			}, success: function(data, status,requestCode,response, xhr) {
				//alert(JSON.stringify(data));
				//alert('suc:' + data);
				//alert(data.log);
				//return;
				MhAcc.checkLogin2({r: data, show_err: true, auto_redirect: true});
				if (data.materialGroup) {
					setData(data.materialGroup.id, data, true);
				}
				deferred.resolve(data.materialGroup);
			}
		});
		return deferred.promise;
	};
  
  return {
	cache: cache
	, get: get
	, approve: approve
	, setData: setData
  };
})
;
