﻿angular.module('mhzs.services')

.factory('MhPopover', function($rootScope, $state, $stateParams, $q, $ionicPopover, MhEnv, MhUtils, MhAcc) {
	//var base_path = MhEnv.getAppPath();
	var cache = {};

	function init(scope, popalias) {
		var deferred = $q.defer();
		$ionicPopover.fromTemplateUrl("templates\\popover_" + popalias + ".html", {
			scope: scope
		})
		.then(function(popover){
			//scope.popover = popover;
			cache["popover_" + popalias] = popover;
			//console.log('init', popalias, popover);
			deferred.resolve({scope: scope, popalias: popalias});
		})
		;
		
		//scope.openPopover = function($event) {
		//	scope.popover.show($event);
		//};
		//scope.closePopover = function() {
		//	scope.popover.hide();
		//};
		if (scope) {
			//销毁事件回调处理：清理popover对象
			scope.$on("$destroy", function() {
				//scope.popover.remove();
				//console.log('...........destroy', popalias);
				if (cache["popover_" + popalias]) {
					cache["popover_" + popalias].remove();
					cache["popover_" + popalias] = null;
				}
			});
			// 隐藏事件回调处理
			scope.$on("popover.hidden", function() {
				// Execute action
				//console.log('...........hidden');
			});
			//删除事件回调处理
			scope.$on("popover.removed", function() {
				// Execute action
				//console.log('...........removed');
			});
		}
		return deferred.promise;
	}
	
	function run(scope, $event, popalias, fun) {
	//console.log('popover...run...', fun);
		var popover = cache["popover_" + popalias];
		//console.log('run', popalias, popover);
		if (!popover) {
			//console.log('########## recreate popover', popalias);
			init(scope, popalias).then(function() {
				run(scope, $event, popalias, fun);
			});
		} else if (popover) {
			if (fun == 'show') {
				popover.show($event);
			} else if (fun == 'hide') {
				popover.hide();
			} else if (fun == 'remove') {
				popover.remove();
				cache["popover_" + popalias] = null;
			}
		}
	}
  
  return {
	cache: cache
	, init: init
	, run: run
  };
})
;
