﻿angular.module('mhzs.services')

.factory('MhProject', function($rootScope, $state, $stateParams, $q, MhEnv, MhUtils, MhAcc, MhBudget, MhPay) {
  //var base_path = MhEnv.getAppPath();
	var cache = {prjs: {}};

	var project_my = function() {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_Prj_My;
		jQuery.ajax({
			type: 'POST'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode,response, xhr) {
				//if (window.show_project) show_project(r);
				//if (args.callback) args.callback(r);
				MhAcc.checkLogin2({r: r, show_err: true, auto_redirect: true});
				cache.listmy = r;
				deferred.resolve(r);
			}, error: function(xhr, errorType, error,msg) {
				//alert('error');
				//alert(msg);
				//alert( '1.获取项目出错！' );
				MhUtils.toast({type: 'error', message: '获取项目出错！\n(' + MhEnv.api + Const.Url_Prj_My + ')\n' + msg});
				deferred.reject(error);
			}
		});
		return deferred.promise;
	}
	
	var project_get = function(id) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_Prj;
		url = url.replace(/(\$\{id\})/, id);
		jQuery.ajax({
			type: 'GET'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode,response, xhr) {
				//if (args.callback) args.callback(r);
				MhAcc.checkLogin2({r: r, show_err: true, auto_redirect: true});
				if (r && r.model && r.model.id) {
					cache.prjs[r.model.id] = r;
					MhBudget.list({id: r.model.id}).then(function(rBudget) {
						cache.prjs[r.model.id].listBudget = rBudget.listBudget;
						cache.prjs[r.model.id].listBudgetItem = rBudget.listBudgetItem;
					}, function() {});
					MhPay.list({id: r.model.id}).then(function(rPay) {
						cache.prjs[r.model.id].listPay = rPay.listPay;
					}, function() {});
				}
				deferred.resolve(r);
			}, error: function(xhr, errorType, error,msg) {
				//alert('error');
				//alert(error + ':' + msg);
				//alert( '2.获取项目出错！' );
				MhUtils.toast({type: 'error', message: '获取项目出错2！\n(' + MhEnv.api + Const.Url_Prj + ')\n' + msg});
				deferred.reject(error);
			}
		});
		return deferred.promise;
	}
	
	var current = function() {
		return cache.currentId ? cache.prjs[cache.currentId] : null;
	};
	
	var getPrj = function(prjId) {
		return cache.prjs[prjId];
	};
	
	var getStep = function(prjId, stepId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listStep && i<prj.listStep.length; i++) {
				if (prj.listStep[i].id == stepId) return prj.listStep[i];
			}
		}
		return null;
	};
	
	var setStep = function(prjId, stepId, step) {
		var prj = getPrj(prjId);
		if (prj) {
			var step0 = getStep(prjId, stepId);
			if (step0) {
				$.extend(step0, step);
			} else {
				prj.listStep.push(step);
			}
		}
		return null;
	};
	
	var getMaterial = function(prjId, materialId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listMaterialGroup && i<prj.listMaterialGroup.length; i++) {
				if (prj.listMaterialGroup[i].id == materialId) return prj.listMaterialGroup[i];
			}
		}
		return null;
	};
	
	var setMaterial = function(prjId, materialId, material) {
		var prj = getPrj(prjId);
		if (prj) {
			var material0 = getMaterial(prjId, materialId);
			if (material0) {
				$.extend(material0, material);
			} else {
				prj.listMaterialGroup.push(material);
			}
		}
		return null;
	};
	
	var getCheckItem = function(prjId, checkItemId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listCheckItem && i<prj.listCheckItem.length; i++) {
				if (prj.listCheckItem[i].id == checkItemId) return prj.listCheckItem[i];
			}
		}
		return null;
	};
	
	var setCheckItem = function(prjId, checkItemId, checkItem) {
		var prj = getPrj(prjId);
		if (prj) {
			var checkItem0 = getCheckItem(prjId, checkItemId);
			if (checkItem0) {
				$.extend(checkItem0, checkItem);
			} else {
				prj.listCheckItem.push(checkItem);
			}
			var checkItem1 = getCheckItem(prjId, checkItemId);
			var check = getCheck(prjId, checkItem1.checkId);
			check.chk = checkItem1.chk;
			check.chkPm = checkItem1.chkPm;
			check.chkSup = checkItem1.chkSup;
			check.chkCust = checkItem1.chkCust;
		}
		return null;
	};
	
	var getCheck = function(prjId, checkId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listCheck && i<prj.listCheck.length; i++) {
				if (prj.listCheck[i].id == checkId) return prj.listCheck[i];
			}
		}
		return null;
	};
	
	var setCheck = function(prjId, checkId, check) {
		var prj = getPrj(prjId);
		if (prj) {
			var check0 = getCheck(prjId, checkId);
			if (check0) {
				$.extend(check0, check);
			} else {
				prj.listCheck.push(check);
			}
		}
		return null;
	};
	
	var getBudgetItem = function(prjId, budgetItemId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listBudgetItem && i<prj.listBudgetItem.length; i++) {
				if (prj.listBudgetItem[i].id == budgetItemId) return prj.listBudgetItem[i];
			}
		}
		return null;
	};
	
	var setBudgetItem = function(prjId, budgetItemId, budgetItem) {
		var prj = getPrj(prjId);
		if (prj) {
			var budgetItem0 = getBudgetItem(prjId, budgetItemId);
			if (budgetItem0) {
				$.extend(budgetItem0, budgetItem);
			} else {
				prj.listBudgetItem.push(budgetItem);
			}
		}
		return null;
	};
	
	var getBudget = function(prjId, budgetId) {
		var prj = getPrj(prjId);
		if (prj) {
			for (var i=0; prj.listBudget && i<prj.listBudget.length; i++) {
				if (prj.listBudget[i].id == budgetId) return prj.listBudget[i];
			}
		}
		return null;
	};
	
	var setBudget = function(prjId, budgetId, budget) {
		var prj = getPrj(prjId);
		if (prj) {
			var budget0 = getBudget(prjId, budgetId);
			if (budget0) {
				$.extend(budget0, budget);
			} else {
				prj.listBudget.push(budget);
			}
		}
		return null;
	};
  
  return {
	cache: cache
	, project_my: project_my
	, project_get: project_get
	, current: current
	, getPrj: getPrj
	, getStep: getStep
	, setStep: setStep
	, getMaterial: getMaterial
	, setMaterial: setMaterial
	, getCheck: getCheck
	, setCheck: setCheck
	, getCheckItem: getCheckItem
	, setCheckItem: setCheckItem
	, getBudget: getBudget
	, setBudget: setBudget
	, getBudgetItem: getBudgetItem
	, setBudgetItem: setBudgetItem
  };
})
;
