﻿angular.module('mhzs.services')

.factory('MhStep', function($rootScope, $state, $stateParams, $q, MhEnv, MhUtils, MhAtt, MhAcc, MhProject) {
  //var base_path = MhEnv.getAppPath();
	var cache = {_steps: {}};

	var step = function(prjId, id) {
		var deferred = $q.defer();
		var url = MhEnv.api + Const.Url_Step;
		url = url.replace(/(\$\{id\})/, id)
			.replace(/(\$\{prjId\})/, prjId)
		;
		jQuery.ajax({
			type: 'GET'
			, url: url
			, timeout: Const.Http_Timeout
			, dataType: 'json'
			//, offline: true
			//, expires: 10000
			, data: {rnd: Math.random()}
			, success: function(r, status, requestCode) {
				//if (args.callback) args.callback(r);
				//console.log('xxxxxxxxxxx', r);
				MhAcc.checkLogin2({r: r, show_err: true, auto_redirect: true});
				if (r.step && r.step.id) {
					//cache._steps[r.step.id] = r;
					setStep(r.step.id, r);
					var viewId = 'step_' + r.step.id;
					var view = MhAtt.viewClear(viewId);
					MhAtt.refreshAtts(r.listAttach);
					for (var i=0; r.listAttach && i<r.listAttach.length; i++) {
						MhAtt.viewPush(viewId, r.listAttach[i].id);
					}
				}
				deferred.resolve(r);
			}, error: function(xhr, errorType, error) {
				//alert('error');
				//alert(error + ':' + msg);
				//alert('获取进度信息出错！');
				//console.log('error', errorType, error);
				MhUtils.toast({type: 'error', message: '获取进度信息出错！\n(' + MhEnv.api + Const.Url_Step + ')\n' + error});
				deferred.reject(error);
			}
		});
		return deferred.promise;
	};
	
	var setStep = function(id, _stepWrap, steponly) {
		if (!cache._steps[id]) cache._steps[id] = {step: {}};
		if (steponly) {
			if (_stepWrap.step) $.extend(cache._steps[id].step, _stepWrap.step);
		} else {
			$.extend(cache._steps[id], _stepWrap);
		}
		if (_stepWrap.step) {
			MhProject.setStep(_stepWrap.step.prjId, _stepWrap.step.id, _stepWrap.step);
		}
	};
	
	var approve = function(args) {
		var deferred = $q.defer();
		var approve = args.approve;
		//var approve = jQuery(this).is('.step_approve_undo') ? 'undo' : jQuery(this).is('.step_approve_doing') ? 'doing' : 'done';
		//step_id
		var url = MhEnv.api + Const.Url_StepApprove;
		jQuery.ajax({
			type: 'POST'
			, url: url
			, data: {stepId:args.id, approve: approve}
			, dataType: 'json'
			, timeout: 20000
			, error: function(xhr, errorType, error) {
				alert('网络连接出现问题！\n(' + url + ')');
				deferred.reject(error);
			}, success: function(data, status,requestCode,response, xhr) {
				MhAcc.checkLogin2({r: data, show_err: true, auto_redirect: true});
				//alert(JSON.stringify(data));
				//alert('suc:' + data);
				//alert(data.log);
				//return;
				if (data.step) {
					setStep(data.step.id, data, true);
					
					//jQuery('.step_time').html(
					//	(data.step.time0 != null ? data.step.time0.toDate().format('yyyy-MM-dd') : '')
					//	+ ' 至 ' 
					//	+ (data.step.time1 != null ? data.step.time1.toDate().format('yyyy-MM-dd') : '')
					//);
					//set_step_status(data.step.id, data.step.status);
				}
				deferred.resolve(data.step);
			}
		});
		return deferred.promise;
	};
	
  
  return {
	cache: cache
	, step: step
	, approve: approve
	, setStep: setStep
  };
})
;
