angular.module('mhzs.services')

.factory('MhUtils', function($resource, $state, $rootScope, $ionicActionSheet, MhEnv) {
	var cache = {toast_last: null};

	var rotateLeft = function(lValue, iShiftBits) {
		return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
	}
	var addUnsigned = function(lX, lY) {
		var lX4, lY4, lX8, lY8, lResult;
		lX8 = (lX & 0x80000000);
		lY8 = (lY & 0x80000000);
		lX4 = (lX & 0x40000000);
		lY4 = (lY & 0x40000000);
		lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
		if (lX4 & lY4) return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
		if (lX4 | lY4) {
			if (lResult & 0x40000000) return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
			else return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
		} else {
			return (lResult ^ lX8 ^ lY8);
		}
	}
	var F = function(x, y, z) {
		return (x & y) | ((~ x) & z);
	}
	var G = function(x, y, z) {
		return (x & z) | (y & (~ z));
	}
	var H = function(x, y, z) {
		return (x ^ y ^ z);
	}
	var I = function(x, y, z) {
		return (y ^ (x | (~ z)));
	}
	var FF = function(a, b, c, d, x, s, ac) {
		a = addUnsigned(a, addUnsigned(addUnsigned(F(b, c, d), x), ac));
		return addUnsigned(rotateLeft(a, s), b);
	};
	var GG = function(a, b, c, d, x, s, ac) {
		a = addUnsigned(a, addUnsigned(addUnsigned(G(b, c, d), x), ac));
		return addUnsigned(rotateLeft(a, s), b);
	};
	var HH = function(a, b, c, d, x, s, ac) {
		a = addUnsigned(a, addUnsigned(addUnsigned(H(b, c, d), x), ac));
		return addUnsigned(rotateLeft(a, s), b);
	};
	var II = function(a, b, c, d, x, s, ac) {
		a = addUnsigned(a, addUnsigned(addUnsigned(I(b, c, d), x), ac));
		return addUnsigned(rotateLeft(a, s), b);
	};
	var convertToWordArray = function(string) {
		var lWordCount;
		var lMessageLength = string.length;
		var lNumberOfWordsTempOne = lMessageLength + 8;
		var lNumberOfWordsTempTwo = (lNumberOfWordsTempOne - (lNumberOfWordsTempOne % 64)) / 64;
		var lNumberOfWords = (lNumberOfWordsTempTwo + 1) * 16;
		var lWordArray = Array(lNumberOfWords - 1);
		var lBytePosition = 0;
		var lByteCount = 0;
		while (lByteCount < lMessageLength) {
			lWordCount = (lByteCount - (lByteCount % 4)) / 4;
			lBytePosition = (lByteCount % 4) * 8;
			lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
			lByteCount++;
		}
		lWordCount = (lByteCount - (lByteCount % 4)) / 4;
		lBytePosition = (lByteCount % 4) * 8;
		lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
		lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
		lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
		return lWordArray;
	};
	var wordToHex = function(lValue) {
		var WordToHexValue = "", WordToHexValueTemp = "", lByte, lCount;
		for (lCount = 0; lCount <= 3; lCount++) {
			lByte = (lValue >>> (lCount * 8)) & 255;
			WordToHexValueTemp = "0" + lByte.toString(16);
			WordToHexValue = WordToHexValue + WordToHexValueTemp.substr(WordToHexValueTemp.length - 2, 2);
		}
		return WordToHexValue;
	};
	var uTF8Encode = function(string) {
		string = string.replace(/\x0d\x0a/g, "\x0a");
		var output = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				output += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				output += String.fromCharCode((c >> 6) | 192);
				output += String.fromCharCode((c & 63) | 128);
			} else {
				output += String.fromCharCode((c >> 12) | 224);
				output += String.fromCharCode(((c >> 6) & 63) | 128);
				output += String.fromCharCode((c & 63) | 128);
			}
		}
		return output;
	};
	var md5 = function(string) {
		var x = Array();
		var k, AA, BB, CC, DD, a, b, c, d;
		var S11=7, S12=12, S13=17, S14=22;
		var S21=5, S22=9 , S23=14, S24=20;
		var S31=4, S32=11, S33=16, S34=23;
		var S41=6, S42=10, S43=15, S44=21;
		string = uTF8Encode(string);
		x = convertToWordArray(string);
		a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
		for (k = 0; k < x.length; k += 16) {
			AA = a; BB = b; CC = c; DD = d;
			a = FF(a, b, c, d, x[k+0],  S11, 0xD76AA478);
			d = FF(d, a, b, c, x[k+1],  S12, 0xE8C7B756);
			c = FF(c, d, a, b, x[k+2],  S13, 0x242070DB);
			b = FF(b, c, d, a, x[k+3],  S14, 0xC1BDCEEE);
			a = FF(a, b, c, d, x[k+4],  S11, 0xF57C0FAF);
			d = FF(d, a, b, c, x[k+5],  S12, 0x4787C62A);
			c = FF(c, d, a, b, x[k+6],  S13, 0xA8304613);
			b = FF(b, c, d, a, x[k+7],  S14, 0xFD469501);
			a = FF(a, b, c, d, x[k+8],  S11, 0x698098D8);
			d = FF(d, a, b, c, x[k+9],  S12, 0x8B44F7AF);
			c = FF(c, d, a, b, x[k+10], S13, 0xFFFF5BB1);
			b = FF(b, c, d, a, x[k+11], S14, 0x895CD7BE);
			a = FF(a, b, c, d, x[k+12], S11, 0x6B901122);
			d = FF(d, a, b, c, x[k+13], S12, 0xFD987193);
			c = FF(c, d, a, b, x[k+14], S13, 0xA679438E);
			b = FF(b, c, d, a, x[k+15], S14, 0x49B40821);
			a = GG(a, b, c, d, x[k+1],  S21, 0xF61E2562);
			d = GG(d, a, b, c, x[k+6],  S22, 0xC040B340);
			c = GG(c, d, a, b, x[k+11], S23, 0x265E5A51);
			b = GG(b, c, d, a, x[k+0],  S24, 0xE9B6C7AA);
			a = GG(a, b, c, d, x[k+5],  S21, 0xD62F105D);
			d = GG(d, a, b, c, x[k+10], S22, 0x2441453);
			c = GG(c, d, a, b, x[k+15], S23, 0xD8A1E681);
			b = GG(b, c, d, a, x[k+4],  S24, 0xE7D3FBC8);
			a = GG(a, b, c, d, x[k+9],  S21, 0x21E1CDE6);
			d = GG(d, a, b, c, x[k+14], S22, 0xC33707D6);
			c = GG(c, d, a, b, x[k+3],  S23, 0xF4D50D87);
			b = GG(b, c, d, a, x[k+8],  S24, 0x455A14ED);
			a = GG(a, b, c, d, x[k+13], S21, 0xA9E3E905);
			d = GG(d, a, b, c, x[k+2],  S22, 0xFCEFA3F8);
			c = GG(c, d, a, b, x[k+7],  S23, 0x676F02D9);
			b = GG(b, c, d, a, x[k+12], S24, 0x8D2A4C8A);
			a = HH(a, b, c, d, x[k+5],  S31, 0xFFFA3942);
			d = HH(d, a, b, c, x[k+8],  S32, 0x8771F681);
			c = HH(c, d, a, b, x[k+11], S33, 0x6D9D6122);
			b = HH(b, c, d, a, x[k+14], S34, 0xFDE5380C);
			a = HH(a, b, c, d, x[k+1],  S31, 0xA4BEEA44);
			d = HH(d, a, b, c, x[k+4],  S32, 0x4BDECFA9);
			c = HH(c, d, a, b, x[k+7],  S33, 0xF6BB4B60);
			b = HH(b, c, d, a, x[k+10], S34, 0xBEBFBC70);
			a = HH(a, b, c, d, x[k+13], S31, 0x289B7EC6);
			d = HH(d, a, b, c, x[k+0],  S32, 0xEAA127FA);
			c = HH(c, d, a, b, x[k+3],  S33, 0xD4EF3085);
			b = HH(b, c, d, a, x[k+6],  S34, 0x4881D05);
			a = HH(a, b, c, d, x[k+9],  S31, 0xD9D4D039);
			d = HH(d, a, b, c, x[k+12], S32, 0xE6DB99E5);
			c = HH(c, d, a, b, x[k+15], S33, 0x1FA27CF8);
			b = HH(b, c, d, a, x[k+2],  S34, 0xC4AC5665);
			a = II(a, b, c, d, x[k+0],  S41, 0xF4292244);
			d = II(d, a, b, c, x[k+7],  S42, 0x432AFF97);
			c = II(c, d, a, b, x[k+14], S43, 0xAB9423A7);
			b = II(b, c, d, a, x[k+5],  S44, 0xFC93A039);
			a = II(a, b, c, d, x[k+12], S41, 0x655B59C3);
			d = II(d, a, b, c, x[k+3],  S42, 0x8F0CCC92);
			c = II(c, d, a, b, x[k+10], S43, 0xFFEFF47D);
			b = II(b, c, d, a, x[k+1],  S44, 0x85845DD1);
			a = II(a, b, c, d, x[k+8],  S41, 0x6FA87E4F);
			d = II(d, a, b, c, x[k+15], S42, 0xFE2CE6E0);
			c = II(c, d, a, b, x[k+6],  S43, 0xA3014314);
			b = II(b, c, d, a, x[k+13], S44, 0x4E0811A1);
			a = II(a, b, c, d, x[k+4],  S41, 0xF7537E82);
			d = II(d, a, b, c, x[k+11], S42, 0xBD3AF235);
			c = II(c, d, a, b, x[k+2],  S43, 0x2AD7D2BB);
			b = II(b, c, d, a, x[k+9],  S44, 0xEB86D391);
			a = addUnsigned(a, AA);
			b = addUnsigned(b, BB);
			c = addUnsigned(c, CC);
			d = addUnsigned(d, DD);
		}
		var tempValue = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);
		return tempValue.toLowerCase();
	}

	function layerAlert(content, time_wait, end_state) {
		layer.open({
		    content: content,
		    style: 'background-color:#fff; color:#000; border:none;',
		    shadeClose:false,
		    time: time_wait || 2
			, end:function(){
				//window.location.href = forwardurl;
				if (end_state != undefined && end_state) {
					$state.go(end_state.state.name, end_state.params);
					//$state.go(end_state.name, end_state.params);
				}
			}
		});
	}

	function toast(options, onSuccess, onError) {
		if (window.plugins && window.plugins.toast) {
			options.position = options.position || 'bottom';
			options.duration = options.duration || 'short';
			options.target = null;
			try {
				window.plugins.toast.showWithOptions(options, function() {}, function() {});	
			} catch (e) {
				alert(e);
			}
			
		} else if (window.toastr){
			if (cache.toast_last && (options.preventDuplicates == undefined || options.preventDuplicates)) {
				cache.toast_last.remove();
			}
			var position = options.position || 'toast-bottom-center';
			if (position == 'bottom') {
				position = 'toast-bottom-center';
			}
			var timeOut = options.timeOut || options.duration || 2000;
			if (timeOut == 'short') {
				timeOut = 2000;
			} else if (timeOut == 'long') {
				timeOut = 6000;
			}
			toastr.options = {
				tapToDismiss: true,
				toastClass: 'toast',
				containerId: 'toast-container',
				showMethod: 'fadeIn', //fadeIn, slideDown, and show are built into jQuery
				showDuration: 300,
				showEasing: 'swing', //swing and linear are built into jQuery
				onShown: undefined,
				hideMethod: 'fadeOut',
				hideDuration: 600,
				hideEasing: 'swing',
				onHidden: undefined,
				closeMethod: false,
				closeDuration: false,
				closeEasing: false,
				extendedTimeOut: 600,
				iconClasses: {
					error: 'toast-error',
					info: 'toast-info',
					success: 'toast-success',
					warning: 'toast-warning'
				},
				iconClass: 'toast-info',
				positionClass: 'toast-top-right',
				timeOut: timeOut, // Set timeOut and extendedTimeOut to 0 to make it sticky
				titleClass: 'toast-title',
				messageClass: 'toast-message',
				escapeHtml: false,
				target: options.target || 'body',
				closeHtml: '<button type="button">&times;</button>',

                closeButton: false,
                debug: false,
                newestOnTop: false,
                progressBar: false,
                positionClass: position,
                preventDuplicates: false,
                onclick: null
            };
			cache.toast_last = toastr[options.type || 'info'](options.message, options.title||'');
		}
	}

	function share_www() {
		var items = [{share: 'qzone', text: 'QQ空间'}
			, {share: 'tqq', text: '腾讯微博'}
			, {share: 'sqq', text: 'QQ好友'}
			, {share: 'weixin', text: '微信'}
			, {share: 'tsina', text: '新浪微博'}
		];
		var buttons = [];
		for (var i=0; i<items.length; i++) {
			buttons.push({text: '<i share="' + items[i].share + '">' + items[i].text + '</i>'});
		}
        $ionicActionSheet.show({
            titleText: '分享给朋友',
            buttons: buttons,
            cancelText: '取消',
            cancel: function() {
                console.log('CANCELLED');
            },
            buttonClicked: function(index) {
                console.log('BUTTON CLICKED', index);
				var item = items[index];
				var img = getHostUrl(MhEnv.api + '/img/icon.png');
				share(6, item.share, '[好玩]', '旅行观天下', [img], getHostUrl(location.href) );

            },
            destructiveButtonClicked: function() {
                console.log('DESTRUCT');
                return true;
            }
        });
	}

	/**  bdshare */
	function bdshare(max, cmd, message, subject, fileOrFileArray, url, successCallback, errorCallback) {
		if (!window._bd_share_main || !window._bd_share_main.F) {
			if (max) {
				setTimeout(function() {init_bdshare(--max)}, 250);
			}
		} else {

			window._bd_share_main.F.module("share/mhtz", function(e, t, n) {
				var r = e("base/tangram").T
				  , i = e("base/class").Class;

				var a;

				var share = function(cmd, message, subject, fileOrFileArray, url, successCallback, errorCallback) {
					var f = r.extend({}, a, {
						__type: "imgshare",
						__buttonType: "",
						__cmd: cmd || "tqq",
						__element: new Image()
						, bdUrl: url
						, bdPic: fileOrFileArray ? fileOrFileArray[0] : ""
						, bdText: subject || "[旅行观天下]"
						, bdDesc: ""
						, bdComment: message || ""
						, viewStyle: "0"
						, viewText: subject || ""
						, viewType: "list"
					});
					window._bd_share_main.F.use("trans/trans", function(e) {
						e.run(f)
					});
				};

				return {share: share};
			});
			window._bd_share_main.F.use("share/mhtz", function(mh) {
				//alert(trans);
				//trans.run(f);
				//console.log(mh);
				mh.share(cmd, message, subject, fileOrFileArray, url, successCallback, errorCallback);
			});
		}
	}

	/** 返回后台remote url */
	function getApiUrl(url) {
		var p0 = url.indexOf('http://');
		if (p0 == 0) {
			p0 = url.indexOf('/', 'http://'.length);
			var p1 = url.indexOf('/', p0+1);
			if (p1 != -1) {
				return MhEnv.apiRemote + url.substring(p1);
			}
		} else {
			return MhEnv.apiRemote + url;
		}
	}

	/** 返回前台remote url */
	function getHostUrl(url) {
		var p0 = url.indexOf('index.html');
		if (p0 != -1)  {
			return MhEnv.host + '/' + url.substring(p0);
		} else {
			var p0 = url.indexOf('http://');
			if (p0 == 0) {
				p0 = url.indexOf('/', 'http://'.length);
				var p1 = url.indexOf('/', p0+1);
				if (p1 != -1) {
					return MhEnv.host + url.substring(p1);
				}
			}
		}
		return url;
	}

	function share(max, cmd, message, subject, fileOrFileArray, url, successCallback, errorCallback) {
		//window.plugins.socialsharing.share('Message, subject, image and link', 'The subject', 'https://www.google.nl/images/srpr/logo4w.png', 'http://www.x-services.nl')
		if (window.plugins && window.plugins.socialsharing) {
			window.plugins.socialsharing.share(message, subject, fileOrFileArray, url, successCallback, errorCallback)
		} else {
			bdshare(max, cmd, message, subject, fileOrFileArray, url, successCallback, errorCallback);
		}
	}

  var resRegCode =  $resource(MhEnv.api + '/regist/getRegCode.htm', {}, {
    query: {method: 'get', isArray:false, params: {mobile: null, type: null}, timeout: 20000}
  });
  var getRegCode = function(scope, mobile, type, callback) {
	return resRegCode.query({
	  mobile: mobile, type: type
    }, function(r) {
      return callback && callback(r);
    });
  };
  
  var isEmpty = function(obj) {
	for (var k in obj) {
		return false;
	}
	return true;
  };
  
  var stateInit = function() {
	cache.Event_StateChangeStart = {};
	cache.Event_StateChangeSuccess = {};
	cache.Event_StateChangeStart_Cache = {};
	$rootScope.$on('$stateChangeStart', 
		function(event, toState, toParams, fromState, fromParams){ 
			//event.preventDefault(); 
			//console.log('......1');
			var keyArr = fromState && fromState.name 
				? [fromState.name + '===>' + toState.name, fromState.name + '===>', '===>' + toState.name] 
				: ['===>' + toState.name];
			for (var j=0; j<keyArr.length; j++) {
				var key = keyArr[j];
				var handles = cache.Event_StateChangeStart[key];
				if (handles) {
					for (var i=0; i<handles.length; i++) {
						var handle = handles[i];
						if (!handle.check || handle.check && handle.check(event, toState, toParams, fromState, fromParams)) {
							handle.handle(event, toState, toParams, fromState, fromParams);
						}
						
					}
				}
			}
		}
	);
	$rootScope.$on('$stateChangeSuccess', 
		function(event, toState, toParams, fromState, fromParams){ 
			//event.preventDefault(); 
			//console.log('......1');
			var keyArr = fromState && fromState.name 
				? [fromState.name + '===>' + toState.name, fromState.name + '===>', '===>' + toState.name] 
				: ['===>' + toState.name];
			for (var j=0; j<keyArr.length; j++) {
				var key = keyArr[j];
				var handles = cache.Event_StateChangeSuccess[key];
				if (handles) {
					for (var i=0; i<handles.length; i++) {
						var handle = handles[i];
						if (!handle.check || handle.check && handle.check(event, toState, toParams, fromState, fromParams)) {
							handle.handle(event, toState, toParams, fromState, fromParams);
						}
						
					}
				}
			}
		}
	);
  };
  
  var stateChangeStartReg = function(key, check, handle, handleId) {	//指定handleId可避免重复注册事件处理
	if (!cache.Event_StateChangeStart) {
		stateInit();
	}
	var handles = cache.Event_StateChangeStart[key];
	if (!handles) handles = cache.Event_StateChangeStart[key] = [];
	if (!handleId) {
		handles.push({check: check, handle: handle});
	} else if (handles.indexOf(handleId, 'id') == -1) {
		handles.push({check: check, handle: handle, id: handleId});
	}
  };
  
  var stateChangeSuccessReg = function(key, check, handle, handleId) {
	if (!cache.Event_StateChangeSuccess) {
		stateInit();
	}
	var handles = cache.Event_StateChangeSuccess[key];
	if (!handles) handles = cache.Event_StateChangeSuccess[key] = [];
	if (!handleId) {
		handles.push({check: check, handle: handle});
	} else if (handles.indexOf(handleId, 'id') == -1) {
		handles.push({check: check, handle: handle, id: handleId});
	}
  };
	
	var rx = {
		cache: cache
		, md5: md5
		, isEmpty: isEmpty
		, stateInit: stateInit
		, stateChangeStartReg: stateChangeStartReg
		, stateChangeSuccessReg: stateChangeSuccessReg
		, layerAlert: layerAlert
		, toast: toast
		, share: share
		, share_www: share_www
		, getHostUrl: getHostUrl
		, getApiUrl: getApiUrl
		, getRegCode: getRegCode
		, appInfo: {version: window.AppVersion ? window.AppVersion.version: null
			, build: window.AppVersion ? window.AppVersion.build : null
		}, platform: {
			isIOS: ionic.Platform.isIOS()
			, isIPad: ionic.Platform.isIPad()
			, isAndroid: ionic.Platform.isAndroid()
			, isWebView: ionic.Platform.isWebView()
			, platform: ionic.Platform.platform()
			, platformVersion: ionic.Platform.version()
		}
	};
	
	rx.getAppInfo = function() {
		rx.appInfo = {version: window.AppVersion ? window.AppVersion.version: null
			, build: window.AppVersion ? window.AppVersion.build : null
		};
		return rx.appInfo;
	};
	
	rx.getPlatform = function() {
		rx.platform = {
			isIOS: ionic.Platform.isIOS()
			, isIPad: ionic.Platform.isIPad()
			, isAndroid: ionic.Platform.isAndroid()
			, isWebView: ionic.Platform.isWebView()
			, platform: ionic.Platform.platform()
			, platformVersion: ionic.Platform.version()
		};
		return rx.platform;
	};
	
	return rx;
})

;


var Const = {
	DEBUG: false
	//Url_Site: 'http://www.mohocn.com/decorate'
	, Url_ContentPath: '/decorate'
	//, Url_Cfg: 'http://www.mohocn.com/zmj/config.jsp'
	, Url_Ver: '/app/ver.jsp'
	, Url_RegFetchVerify: '/test/sms_2.jsp'
	, Url_RegJoin: '/auth/!join'
	, Url_ForgetpwdRepwd: '/auth/!repwd2'
    , Url_SignIn: '/auth/!signIn'
	, Url_SignOut: '/auth/!signOut'
	, Url_Repwd: '/admin/org/user/!repwd'
	, Url_IndexUser: '/index/!indexUser?useronly=${useronly}'
	, Url_ProcIndex: '/auth/!process?auth_key=${auth_key}&returnUrl=${contentPath}${returnUrl}'
    , Url_Prj_My: '/admin/decorate/project/!listmy'
    , Url_Prj: '/admin/decorate/project/!show?s_budget=0&s_pay=0&model.id=${id}&result.json=1'
    , Url_Step: '/admin/decorate/project/!step?prjId=${prjId}&id=${id}&result.json=1'
	, Url_ListPay: '/admin/decorate/project/!listPay?model.id=${id}&result.json=1'
	, Url_ListBudget: '/admin/decorate/project/!listBudget?model.id=${id}&result.json=1'
	, Url_ListBudgetItem: '/admin/decorate/project/!listBudgetItem?budgetId=${budgetId}&result.json=1'
	, Url_MaterialGroup: '/admin/decorate/project/!materialGroup?prjId=${prjId}&id=${id}&result.json=1'
	, Url_CheckItem: '/admin/decorate/project/!checkItem?prjId=${prjId}&id=${id}&result.json=1'
	, Url_Clock: '/admin/decorate/project/!clock?d=${d}&result.json=1'
	, Url_Clock_Update: '/admin/decorate/project/!clockUpdate?d=${d}&result.json=1'
	, Url_StepApprove: '/admin/decorate/project/!stepApprove?result.json=1'
	, Url_MaterialGroupApprove: '/admin/decorate/project/!materialGroupApprove?result.json=1'
	, Url_CheckLogApprove: '/admin/decorate/project/!checkLogApprove?result.json=1'
    , Url_Attach_Upload: '/web/attach/!upload'
	, Url_Attach_Down: '/web/attach/!down?model.id=${id}&r=1'
	, Url_Attach_Info: '/web/attach/!show?model.id=${id}&result.json=1'
	, Url_Attach_Thumb: '/web/attach/!thumb?model.id=${id}&w=${w}&h=${h}'
	, Url_Msgs: '/admin/decorate/project/!msgs?prjId=${prjId}'
	, Url_MsgSend: '/admin/decorate/project/!msgSend'
	, Url_UserRole: '/admin/decorate/project/!userRole'
	, Sesout: 10
	, Reg_VerifyTime: 60
	, Http_Timeout: 20000
	, Step_Status: {'undo': '未开工', 'doing': '正在施工', 'done': '已完工'}
	, MaterialGroup_Status: {'in': '已入场', 'notin': '未入场'}
	, Check_Log: {'-1': '未通过', '0': '正在验收', '1': '验收通过'}
	, Check_Log_Pm: {'-1': '项目经理未申请', '10': '项目经理发起申请', '1': '项目经理尚未再次申请'}
	, Check_Log_Pmx: {'-1': '未申请', '10': '已申请'}
	, Check_Log_Sup: {'-1': '等待项目经理申请', '0': '监理未验收', '10': '监理验收通过', '-2': '监理验收未通过'}
	, Check_Log_Supx: {'-1': ' ', '0': '未验收', '10': '通过', '-2': '未通过'}
	, Check_Log_Cust: {'-1': '等待监理验收', '0': '客户未验收', '10': '客户验收通过', '-2': '客户验收未通过'}
	, Check_Log_Custx: {'-1': ' ', '0': '未验收', '10': '通过', '-2': '未通过'}
};


/** js ext */

String.prototype.repeat = function(n) {
	var r = '';
	for (var i=0; i<n; i++) {
		r += this;
	}
	return r;
}
String.prototype.toDate = function() {
    var d = null;
    try {
        var s = this.trim();
        var dy, dM, dd, dH = 0, dm = 0, ds = 0, dS = 0;
        if (s.indexOf('-') != -1) {
            var p = s.indexOf(' ');
            if (p == -1) p = s.indexOf('T');
            var dp = null;
            var tp = null;
            if (p == -1) {
                dp = s.split('-');
            } else {
                dp = s.substring(0, p).split('-');
                var p2 = s.indexOf('.');
                if (p2 == -1) {
                    tp = s.substring(p+1).split(':');
                } else {
                    tp = s.substring(p+1, p2).split(':');
                    dS = parseInt(s.substring(p2 + 1), 10);
                }
            }
            if (dp != null && dp.length) {
                dy = parseInt(dp[0], 10);
                dM = dp.length > 1 ? parseInt(dp[1], 10) : 1;
                dd = dp.length > 2 ? parseInt(dp[2], 10) : 1;
            }
            if (tp != null && tp.length) {
                dH = parseInt(tp[0], 10);
                dm = tp.length > 1 ? parseInt(tp[1], 10) : 0;
                ds = tp.length > 2 ? parseInt(tp[2], 10) : 0;
            }
            
        } else if (s.indexOf('年') != -1) {
            var p = s.indexOf('年');
            dy = parseInt(s.substring(0, p), 10);
            s = p + 1 < s.length ? s.substring(p+1) : '';
            p = s.indexOf('月');
            if (p != -1) {
                dM = parseInt(s.substring(0, p), 10);
                s = p + 1 < s.length ? s.substring(p+1) : '';
                p = s.indexOf('日');
                if (p != -1) {
                    dd = parseInt(s.substring(0, p), 10);
                    //s = p + 1 < s.length ? s.substring(p+1) : '';
                    //p = s.indexOf('日');
                }
            }
        }
        if (dy) {
            d = new Date(dy, dM - 1, dd, dH, dm, ds, dS);
        }
    } catch (e) {
        //alert(e);
		window.plugins.toast.show(e, 'short', 'bottom');
    }
    return d;
};
/** 返回字符串长度，1个汉字折算为2个长度 
	例：alert("xx看1234".length2());
*/
String.prototype.length2 = function() {
	return this.replace(/[^\x00-\xff]/g,"**").length;
};
/** 按照给定的长度截取字符串
	leng：指定长度，1个汉字折算为2个长度 
	sx：如果需要截断，末尾补充的字符，可以是空串、&nbsp;等，默认为"…"
	例：alert("xx看1234".cutLength(5));
*/
String.prototype.cutLength = function(leng, sx) {
	//var s0 = sx == null ? "&nbsp;" : sx;	//…
	var s0 = sx == null ? "…" : sx;
	var r = "";
	var l = this.length2();
	if (l > leng) {
		var l0 = s0.replace(/&nbsp;/g, '*').length2();
		var n = 1;
		while (r.length2() <= leng - l0 && n <= this.length) {
			r = this.substring(0, n);
			n++;
		}
		if (r.length2() > leng - l0) {
			r = r.substring(0, r.length - 1);
		}
		r += s0;
	} else {
		r = this;
	}
	//alert(r);
	return r;
};

Date.prototype.toCn = function() {
    return this.getFullYear().toCn() + '年' + (this.getMonth() + 1).toCnWithUnit() + '月' + this.getDate().toCnWithUnit() + '日';
}
Date.prototype.format = function(fmt0) {
    var s = fmt0 == undefined || !fmt0 ? 'yyyy-MM-dd HH:mm:ss' : fmt0;
    /**
    var y = date.getFullYear();
    var M = date.getMonth() + 1;
    var d = date.getDate();
    var h = date.getHours();
    var m = date.getMinutes();
    var s = date.getSeconds();
    var S = date.getTime()%1000;
    
    */
    var sYY = this.getFullYear().toString().substring(2, 4);
    var sMM = this.getMonth() > 8 ? '' + (this.getMonth() + 1) : '0' + (this.getMonth() + 1);
    var sdd = this.getDate() > 9 ? '' + (this.getDate()) : '0' + this.getDate();
    var sHH = this.getHours() > 9 ? '' + (this.getHours()) : '0' + this.getHours();
    var smm = this.getMinutes() > 9 ? '' + (this.getMinutes()) : '0' + this.getMinutes();
    var sss = this.getSeconds() > 9 ? '' + (this.getSeconds()) : '0' + this.getSeconds();
    var iS = this.getTime()%1000;
    var sSSS = iS > 99 ? '' + (iS) : iS > 9 ? '0' + (iS) : '00' + iS;

    s = s.replace(/yyyy/g, this.getFullYear())
        .replace(/yy/g, sYY)
        .replace(/MM/g, sMM)
        .replace(/M/g, this.getMonth() + 1)
        .replace(/dd/g, sdd)
        .replace(/d/g, this.getDate())
        .replace(/HH/g, sHH)
        .replace(/H/g, this.getHours())
        .replace(/mm/g, smm)
        .replace(/m/g, this.getMinutes())
        .replace(/ss/g, sss)
        .replace(/s/g, this.getSeconds())
        .replace(/SSS/g, sSSS)
        .replace(/S/g, iS)
    ;
    return s;
};

Array.prototype.indexOf = function(val, key) {
	for (var i=0; i<this.length; i++) {
		if (key) {
			if (this[i][key]==val) return i;
		} else {
			if (this[i]==val) return i;
		}
	}
	return -1;
}
Array.prototype.getItem = function(val, key) {
	var idx = this.indexOf(val, key);
	if (idx != -1) {
		return {index: idx, item: this[idx]};
	}
	return null;
}

if (window.Galleria) {
	Galleria.loadTheme('lib/galleria/galleria.realfox.js');
	Galleria.ready(function() {
		//$.data( $('#galleria')[0], 'galleria' ).show(mhapp.cache.galleria_index || 0);
	});	
}