﻿// Ionic mhzs App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'mhzs' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'mhzs.services' is found in services.js
// 'mhzs.controllers' is found in controllers.js
angular.module('mhzs', ['ionic', 'ngResource', 'ngAnimate', 'mhzs.controllers', 'mhzs.services', 'mhzs.directives', 'mhzs.filters'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
		// org.apache.cordova.statusbar required
		StatusBar.styleDefault();
		//StatusBar.styleLightContent();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
	$ionicConfigProvider.tabs.style('standard'); 
	//$ionicConfigProvider.platform.android.tabs.position('bottom');
	//$ionicConfigProvider.tabs.position('bottom');
	//$ionicConfigProvider.tabs.position('standard');
	$ionicConfigProvider.tabs.position('bottom');
	$ionicConfigProvider.navBar.alignTitle('center');
	$ionicConfigProvider.navBar.positionPrimaryButtons('left');

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
	$stateProvider
  
 	.state('login', {url: '/login', views: {'root': {templateUrl: 'templates/acc/login.html', controller: 'LoginCtrl'}} })

	.state('regist', {url: '/regist', views: {'root': {templateUrl: 'templates/acc/regist.html', controller: 'RegistCtrl'}} })
	
	.state('repwd', {url: '/repwd', views: {'root': {templateUrl: 'templates/acc/repwd.html', controller: 'RepwdCtrl'}} })
	
	.state('repwd2', {url: '/repwd2', views: {'root': {templateUrl: 'templates/acc/repwd2.html', controller: 'Repwd2Ctrl'}} })
  

	// setup an abstract state for the tabs directive		//templateUrl: 'templates/tabs.html' //+ rnd()//, controller: 'TabsPageCtrl'
    .state('tab', {url: '/tab', abstract: true, views: {'root': {templateUrl : 'templates/tabs.html' }} })

	// Each tab has its own nav history stack:
	.state('tab.steps', {url: '/steps', views: {'tab-steps': {templateUrl: 'templates/tab-steps.html', controller: 'StepsCtrl'}} })
	.state('tab.step', {url: '/step/:stepId', views: {'tab-steps': {templateUrl: 'templates/tab-step.html', controller: 'StepCtrl'}} })

	.state('tab.materials', {url: '/materials', views: {'tab-materials': {templateUrl: 'templates/tab-materials.html', controller: 'MaterialsCtrl'}} })
	.state('tab.material', {url: '/material/:materialId', views: {'tab-materials': {templateUrl: 'templates/tab-material.html', controller: 'MaterialCtrl'}} })

    .state('tab.checks', {url: '/checks', views: {'tab-checks': {templateUrl: 'templates/tab-checks.html', controller: 'ChecksCtrl'}} })
	.state('tab.check', {url: '/check/:checkId', views: {'tab-checks': {templateUrl: 'templates/tab-check.html', controller: 'CheckCtrl'}} })
	.state('tab.checkItem', {url: '/checkItem/:checkItemId', views: {'tab-checks': {templateUrl: 'templates/tab-checkItem.html', controller: 'CheckItemCtrl'}} })

	.state('tab.more', {url: '/more', views: {'tab-more': {templateUrl: 'templates/tab-more.html', controller: 'MoreCtrl'}} })
	
	//房屋信息
	.state('prj', {url: '/prj', views: {'root': {templateUrl: 'templates/more/prj.html', controller: 'PrjCtrl'}} })
	.state('budget', {url: '/budget', views: {'root': {templateUrl: 'templates/more/budget.html', controller: 'BudgetCtrl'}} })
	.state('budgetItem', {url: '/budgetItem/:budgetId', views: {'root': {templateUrl: 'templates/more/budgetItem.html', controller: 'BudgetItemCtrl'}} })
	.state('paylog', {url: '/paylog', views: {'root': {templateUrl: 'templates/more/paylog.html', controller: 'PaylogCtrl'}} })
	.state('trace', {url: '/trace', views: {'root': {templateUrl: 'templates/more/trace.html', controller: 'TraceCtrl'}} })
	.state('eval', {url: '/eval', views: {'root': {templateUrl: 'templates/more/eval.html', controller: 'EvalCtrl'}} })
	.state('cfg', {url: '/cfg', views: {'root': {templateUrl: 'templates/more/cfg.html', controller: 'CfgCtrl'}} })
	.state('about', {url: '/about', views: {'root': {templateUrl: 'templates/more/about.html', controller: 'AboutCtrl'}} })
	
	//img viewer
	.state('imgview', {url: '/imgview/:viewId/:attId', views: {'root': {templateUrl: 'templates/imgview.html', controller: 'ImgviewCtrl'}} })
	;	

	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/tab/steps');

});


angular.module('mhzs.directives', ['ionic', 'ngResource', 'ngAnimate']);
angular.module('mhzs.controllers', ['mhzs.services']);
angular.module('mhzs.filters', ['mhzs.services']);
angular.module('mhzs.services', ['ngResource']);