﻿'use strict';
angular.module('mhzs.controllers')

.controller('RegistCtrl', function($scope, $rootScope, $state, MhEnv, MhUtils, MhAcc) {
	$scope.MhAcc = MhAcc;
	$scope.MhEnv = MhEnv;

	var cache = $scope.cache = {
		getCodeDisable: false
		, getCodeBtnText: "获取验证码"
		, regDisable: true
	};

	function getContentElement(eve) {
		var target = $(eve.target).parents('.scroll-content:first');
		return target.length ? target[0] : null;
	}

	var Timeout_Init = 60;
	var waitTime4Code_timer = null;
	var waitTime4Code_timeout = Timeout_Init;
	var ContentEle = null;
	function waitTime4Code() {
		if (waitTime4Code_timeout <= 0) {
			cache.getCodeBtnText = "获取验证码";
			cache.getCodeDisable = false;
			waitTime4Code_timeout = Timeout_Init;
		} else {
			cache.getCodeBtnText = "(" + waitTime4Code_timeout + ")秒后重新获取";
			waitTime4Code_timeout--;
			waitTime4Code_timer = setTimeout(function() {
				waitTime4Code();
				$scope.$apply("");
			}, 1000)
		}
	}

	$scope.getCode = function() {
		ContentEle = getContentElement(event);
		cache.getCodeDisable = true;
		if (!$scope.validData(1, true)) {
			cache.getCodeDisable = false;
		} else {
			waitTime4Code_timeout = Timeout_Init;
			waitTime4Code();
			var reg_seq = $scope.codeSeq = parseInt(Math.random() * 1000);
			MhAcc.getVerifyCode({phone: MhAcc.user_name, seq: reg_seq, m: null, acc: 0}).then(function(code) {
				var r = JSON.parse(code);
				if (!r || !r.err) {
					MhUtils.toast({message: '系统繁忙！', type: 'error', target: ContentEle, duration: 'short' });
				} else if (r.err == -1) {
					MhUtils.toast({message: '帐号或手机号不存在！', type: 'error', target: ContentEle, duration: 'short' });
				} else if (r.err != 1) {
					MhUtils.toast({message: '系统繁忙！', type: 'error', target: ContentEle, duration: 'short' });
				} else if (r.err == 1) {
					setTimeout(function() {
						MhUtils.toast({message: '短信发送成功！', type: 'success', target: ContentEle, duration: 'short' });
					}, 2000);
				}
			});
		}
	}

	$scope.on_keyup = function() {
		ContentEle = getContentElement(event);
		var ele = angular.element(event.target);
		//console.log( angular.element(event.target).attr('name') );
		if ($scope.validData(2, true)) {
			cache.regDisable = false;
		} else {
			cache.regDisable = true;
		}
	}

	$scope.regist = function() {
		ContentEle = getContentElement(event);
		cache.regDisable = true;
		var _mobile = $(ContentEle).find("[name='reg_mobile']").val();
		var _code = $(ContentEle).find("[name='reg_code']").val();
		var _pwd = $(ContentEle).find("[name='reg_pwd']").val();
		var _pwd2 = $(ContentEle).find("[name='reg_pwd2']").val();
		
		MhAcc.reg({d: null, vcode: _code, name: _mobile, mobile: _mobile, password:_pwd}).then(function(r) {
			if (r.err == 1) {
				MhUtils.toast({message: '验证码不正确！', type: 'error', target: ContentEle, duration: 'short' });
			} else if (r.err == 2) {
				MhUtils.toast({message: '无效的姓名！', type: 'error', target: ContentEle, duration: 'short' });
			} else if (r.err == 3) {
				MhUtils.toast({message: '无效的密码！', type: 'error', target: ContentEle, duration: 'short' });
			} else if (r.err == 4) {
				MhUtils.toast({message: '无效的手机号码！', type: 'error', target: ContentEle, duration: 'short' });
			} else if (r.err == 10) {
				MhUtils.toast({message: '指定的手机号码已注册！', type: 'error', target: ContentEle, duration: 'short' });
			} else if (r.err != 0) {
				MhUtils.toast({message: '未知错误！', type: 'error', target: ContentEle, duration: 'short' });
			} else {
				MhAcc.user_name = _mobile;
				MhUtils.toast({message: '帐号注册成功，请登录！', type: 'success', target: ContentEle, duration: 'short' });
				setTimeout(function() {
					//appcan.window.open({ name:'login', data:'login.html', aniId:2 });
					//jQuery.mobile.changePage('#login-page');
					MhAcc.logout(true);
				}, 2000);
				
			}
		});
	}

	$scope.validData = function(type, showmsg) {
		var user_name = MhAcc.user_name;
		if (type == 1) {
			if (user_name == null || user_name == '') {
				if (showmsg) MhUtils.toast({message: '帐号不能为空！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			//var mobile = MhAcc.mobile;
			//if (mobile ==null ||mobile == '') {
			//	if (showmsg) MhUtils.toast({message: '手机号码不能为空！', type: 'error', target: ContentEle, duration: 'short' });
			//	return false;
			//}
			//if (!mobile.match(/^(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
			//	if (showmsg) MhUtils.toast({message: '手机号码格式不正确！', type: 'error', target: ContentEle, duration: 'short' });
			//	return false;
			//}
			return true;
		} else if (type == 2) {
			if (user_name == null || user_name == '') {
				if (showmsg) MhUtils.toast({message: '帐号不能为空！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			var codeOrder = $scope.codeSeq;
			//var codeOrder = MhAcc.cache.codeOrder;
			if (codeOrder ==null ||codeOrder == '') {
				if (showmsg) MhUtils.toast({message: '请先发送验证码！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			//if (codeOrder.length!=3) {
			//	if (showmsg) MhUtils.toast({message: '请先发送验证码！', type: 'error', target: ContentEle, duration: 'short' });
			//	return false;
			//}
			var code = $(ContentEle).find("[name='reg_code']").val();
			if (code ==null ||code == '') {
				if (showmsg) MhUtils.toast({message: '验证码不能为空！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			if (code.length!=6) {
				if (showmsg) MhUtils.toast({message: '手机验证码为6位数字！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			var pwd = $(ContentEle).find("[name='reg_pwd']").val();
			var pwd2 = $(ContentEle).find("[name='reg_pwd2']").val();
			if (pwd ==null ||pwd == '') {
				if (showmsg) MhUtils.toast({message: '用户密码不能为空！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			if (pwd.length < 6) {
				if (showmsg) MhUtils.toast({message: '用户密码至少6个字符！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			if (pwd != pwd2) {
				if (showmsg) MhUtils.toast({message: '两次输入的密码不一致！', type: 'error', target: ContentEle, duration: 'short' });
				return false;
			}
			if (showmsg) MhUtils.toast({message: '数据验证通过！', type: 'success', target: ContentEle, duration: 'short' });
			return true;
		}
	}


});

