﻿'use strict';
angular.module('mhzs.controllers')

.controller('CheckItemCtrl', function($scope, $state, $stateParams, $ionicScrollDelegate, $q, MhEnv, MhUtils, MhVer, MhAcc, MhAtt, MhProject, MhStep, MhCheck) {
	$scope.MhEnv = MhEnv;
	$scope.MhAcc = MhAcc;
	$scope.MhProject = MhProject;
	$scope.MhStep = MhStep;
	$scope.MhCheck = MhCheck;
	
	var cache = $scope.cache = {checkItemId: $stateParams.checkItemId, att_upload: {}, uploading: 0};	//var line_id = $stateParams.lineId;
	
	$scope.filter_att = function(e) {
		return e.checkId == $scope.cache.checkId;
	}

	function form_toggle(disable) {
		$('.step_approve').toggleClass('disable', disable);
		cache.uploading = disable ? 1 : 0;
	}
	
	$scope.addImage = function(logId, ro) {
		MhAtt.addImage({}).then(function(r) {
			if (r && r.rtn && r.rtn.err == 0 && r.rtn.url) {
				var attLog = cache.att_upload[logId];
				if (!attLog) attLog = cache.att_upload[logId] = {pm: [], sup: [], cust: []};
				attLog[ro].push({url: r.rtn.url, upload: 0});
				$scope.$apply('');
			}
		});
	};
	$scope.att_upload_rm = function(logId, ro, index) {
		var attLog = cache.att_upload[logId];
		if (!attLog) attLog = cache.att_upload[logId] = {pm: [], sup: [], cust: []};
		var file = attLog[ro][index];
		if (file.upload == 0) {
			attLog[ro].splice(index, 1);
		}
	};
	$scope.att_upload = function() {
		var deferred = $q.defer();

		if (MhUtils.isEmpty(cache.att_upload)) {
			deferred.resolve();
		} else {
			for (var _logId in cache.att_upload) {
				for (var _ro in cache.att_upload[_logId]) {
					MhAtt.fileUpload({$scope: $scope, files: cache.att_upload[_logId][_ro], attachType: 'checkLog_' + _logId, keyName: _ro}).then(function() {
						//form_toggle(false);
						//MhUtils.toast({type:'success', message: '上传成功！'});
						deferred.resolve();
					});
				}
			}
		}
			
		
		return deferred.promise;
	};
	
	$scope.approve = function(logId, ro, flag) {
		var btn = event.target;
		if ($(btn).is('.disable')) return;
		var prjId = MhProject.cache.currentId;
		var jro = $(btn).parents('.log_' + ro + ':first');
		var idea = jro.find('.log_idea_ta').val();
		form_toggle(true);
		$scope.att_upload().then(function() {
			MhCheck.approve({checkItemId: cache.checkItemId, approve: flag, checkId: cache.checkId, prjId: prjId, logId: logId, ro: ro, idea: idea}).then(function(r) {
				form_toggle(false);
				MhUtils.toast({type:'success', message: '提交成功！'});
				load_data();
			});		
		});

		//$(btn).toggleClass('disable');
		//var approve = $(btn).is('.step_approve_undo') ? 'undo' : $(btn).is('.step_approve_doing') ? 'doing' : 'done';
		

	};
	
	function load_data() {
		var prjId = MhProject.cache.currentId;
		MhCheck.getItem(prjId, cache.checkItemId).then(function(r) {
			$scope.checkItemWrap = MhCheck.cache._checkItems[cache.checkItemId];
			cache.checkId = $scope.checkItemWrap.checkItem.checkId;
			$scope.check = MhCheck.getCheck(prjId, cache.checkId);
			$scope.logx = MhCheck.getLogx($scope.checkItemWrap);
			cache.tempId = -1-(new Date().getTime() * 10000 + parseInt(Math.random() * 10000));
//console.log('item.load', cache.checkId, $scope.check, $scope.checkItemWrap, $scope.logx);
		}, function() {});
	}
	
	load_data();
	
	function on_checkItem_in(event, toState, toParams, fromState, fromParams) {
		var checkItem = MhProject.getCheckItem(MhProject.cache.currentId, toParams.checkItemId);
		if (!checkItem) {
			event.preventDefault();
			$state.go('tab.checks', {}, {reload: true });
		}
	}

	MhUtils.stateChangeStartReg('===>tab.checkItem', null, on_checkItem_in, 1);
})

;
