﻿'use strict';
angular.module('mhzs.controllers')

.controller('MaterialCtrl', function($scope, $stateParams, $ionicScrollDelegate, MhEnv, MhUtils, MhVer, MhAcc, MhAtt, MhProject, MhStep, MhMaterial) {
	$scope.MhEnv = MhEnv;
	$scope.MhUtils = MhUtils;
	$scope.MhAtt = MhAtt;
	$scope.MhAcc = MhAcc;
	$scope.MhProject = MhProject;
	$scope.MhStep = MhStep;
	$scope.MhMaterial = MhMaterial;
	
	var cache = $scope.cache = {materialId: $stateParams.materialId, att_upload: [], uploading: 0};
	
	function form_toggle(disable) {
		$('.materialGroup_approve').toggleClass('disable', disable);
		cache.uploading = disable ? 1 : 0;
	}
	
	$scope.addImage = function() {
		MhAtt.addImage({}).then(function(r) {
			if (r && r.rtn && r.rtn.err == 0 && r.rtn.url) {
				cache.att_upload.push({url: r.rtn.url, upload: 0});
				$scope.$apply('');
			}
		});
	};
	$scope.att_upload_rm = function(index) {
		var file = cache.att_upload[index];
		if (file.upload == 0) {
			cache.att_upload.splice(index, 1);
		}
	};
	$scope.att_upload = function() {
		if (cache.uploading == 0) {
			//cache.uploading = 1;
			form_toggle(true);
			MhAtt.fileUpload({$scope: $scope, files: cache.att_upload, attachType: 'material_' + cache.materialId, keyName: null}).then(function() {
				//cache.uploading = 0;
				//$scope.$apply('');
				form_toggle(false);
				MhUtils.toast({type:'success', message: '上传成功！'});
			});
		}
	};
	
	$scope.approve = function() {
		var btn = event.target;
		if ($(btn).is('.disable')) return;
		//$(btn).toggleClass('disable');
		var approve = $(btn).is('.materialGroup_approve_in') ? 'in' : 'notin';
		form_toggle(true);
		MhMaterial.approve({id: cache.materialId, approve: approve}).then(function(_material) {
			form_toggle(false);
			MhUtils.toast({type:'success', message: '提交成功！'});
		});
	};
	
	function load_data() {
		var prjId = MhProject.cache.currentId;
		MhMaterial.get(prjId, cache.materialId).then(function(r) {
			$scope.materialWrap = MhMaterial.cache._materials[cache.materialId];
		}, function() {});
	}
	
	load_data();
})

;
