﻿/**
 * Created by heqichang on 14/12/5.
 */
angular.module('mhzs.filters')

.filter('date2', function () {
  var NUMBER_STRING = /^\-?\d+$/;
  var toString = Object.prototype.toString;
  var isDate = function(value) {
	return toString.call(value) === '[object Date]';
  }
  
  return function (value, fmt, deftxt) {
    if (!value) return deftxt || '';

	var date = value;
	if (typeof date === 'string') {
		date = NUMBER_STRING.test(date) ? parseInt(date, 10) : date.toDate();
	}
	
	if (typeof date === 'number') {
		date = new Date(date);
	}
	
	if (!isDate(date) || !isFinite(date.getTime())) {
      return deftxt;
    }
	
	return date.format(fmt);
    
  };
})

.filter('text', function () {  
  return function (s, def) {
	if (s == undefined || s == null) return def == undefined ? '' : def;
	return s;
  };
})

.filter('Step_Status', function () {  
  return function (value) {
	return Const.Step_Status[value];
  };
})

.filter('MaterialGroup_Status', function () {  
  return function (value) {
	return Const.MaterialGroup_Status[value];
  };
})

.filter('Check_Class', function () {  
	function getChkClass(chk, ro) {
		if (chk == 10) {
			return 'log_chk_yes';
		} else if (chk == -2) {
			return 'log_chk_no';
		} else if (chk == -1) {
			return 'log_chk_wait2';
		} else if (chk == 0) {
			return 'log_chk_wait';
		} else if (chk == null) {
			return 'log_chk_wait2';
		}
	}
	return function (value) {
		return getChkClass(value);
	};
})

.filter('Check_Log_Pmx', function () {  
  return function (value) {
	return Const.Check_Log_Pmx[value];
  };
})

.filter('Check_Log_Supx', function () {  
  return function (value) {
	return Const.Check_Log_Supx[value];
  };
})

.filter('Check_Log_Custx', function () {  
  return function (value) {
	return Const.Check_Log_Custx[value];
  };
})

.filter('AttUrl', function (MhEnv, MhAtt) {  
  return function (value, full, jsonflag) {
	return MhAtt.url({id: value, full: full, jsonflag: jsonflag});
  };
})
;